import java.awt.*;

import javax.media.j3d.*;
import javax.vecmath.*;

  /**
   * Objet geometrique qui represente une pyramide couleur a base carree
   */
  public class Pyramide extends Shape3D {

    /**
     * Constructeur
     */
    public Pyramide() {
      /**
       * Creation de la geometrie de la pyramide
       */
       // Les coordonnees des 5 sommets de la pyramide
       Point3f sommet = new Point3f( 0.0f,  0.5f,  0.0f);
       Point3f base1  = new Point3f(-0.5f, -0.5f, -0.5f);
       Point3f base2  = new Point3f(-0.5f, -0.5f,  0.5f);
       Point3f base3  = new Point3f( 0.5f, -0.5f,  0.5f);
       Point3f base4  = new Point3f( 0.5f, -0.5f, -0.5f);

       // Les couleurs des 5 faces de la pyramide + le sommet
       Color3f color1 = new Color3f(Color.cyan);    // face avant
       Color3f color2 = new Color3f(Color.magenta); // face arriere
       Color3f color3 = new Color3f(Color.yellow);  // face droite
       Color3f color4 = new Color3f(Color.red);     // face gauche
       Color3f color5 = new Color3f(Color.white);   // sommet
       Color3f color6 = new Color3f(Color.green);   // base

       // Construction de l'objet geometrique TriangleArray constitue de 24
       // points
       QuadArray quadArray = new QuadArray(24,
           QuadArray.COORDINATES |
           QuadArray.COLOR_3);

       // Tableau des points constituant les 4 faces (triangles)
       quadArray.setCoordinates(0, new Point3f[] {
       /* face avant */                 base3,  sommet, sommet,  base2,
       /* face arriere */               base1,  sommet, sommet,  base4,
       /* face droite */                base4,  sommet, sommet,  base3,
       /* face gauche */                base2,  sommet, sommet,  base1,
       /* haut */                       sommet, sommet, sommet,  sommet,
       /* base */                       base2,  base1,  base4,   base3,
       });

       // Tableau des couleurs de chaque face
       quadArray.setColors(0, new Color3f[] {
       /* couleur face avant */         color1, color1, color1, color1,
       /* couleur face arriere  */      color2, color2, color2, color2,
       /* couleur face droite */        color3, color3, color3, color3,
       /* couleur face gauche */        color4, color4, color4, color4,
       /* couleur sommet */             color5, color5, color5, color5,
       /* couleur base */               color6, color6, color6, color6
       });

       this.setGeometry(quadArray);
    }  // fin constructeur
  }  // fin class Pyramide extends Shape3D
